# coding: utf-8

"""
    Contabo API


    OpenAPI spec version: 1.0.0
    Contact: support@contabo.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateInstanceRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'image_id': 'str',
        'product_id': 'str',
        'region': 'str',
        'ssh_keys': 'list[int]',
        'root_password': 'int',
        'user_data': 'str',
        'license': 'str',
        'period': 'int'
    }

    attribute_map = {
        'image_id': 'imageId',
        'product_id': 'productId',
        'region': 'region',
        'ssh_keys': 'sshKeys',
        'root_password': 'rootPassword',
        'user_data': 'userData',
        'license': 'license',
        'period': 'period'
    }

    def __init__(self, image_id='db1409d2-ed92-4f2f-978e-7b2fa4a1ec90', product_id='V1', region='EU', ssh_keys=None, root_password=None, user_data=None, license=None, period=1):  # noqa: E501
        """CreateInstanceRequest - a model defined in Swagger"""  # noqa: E501
        self._image_id = None
        self._product_id = None
        self._region = None
        self._ssh_keys = None
        self._root_password = None
        self._user_data = None
        self._license = None
        self._period = None
        self.discriminator = None
        self.image_id = image_id
        self.product_id = product_id
        self.region = region
        if ssh_keys is not None:
            self.ssh_keys = ssh_keys
        if root_password is not None:
            self.root_password = root_password
        if user_data is not None:
            self.user_data = user_data
        if license is not None:
            self.license = license
        self.period = period

    @property
    def image_id(self):
        """Gets the image_id of this CreateInstanceRequest.  # noqa: E501

        ImageId to be used to setup the compute instance. Default is Ubuntu 20.04  # noqa: E501

        :return: The image_id of this CreateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._image_id

    @image_id.setter
    def image_id(self, image_id):
        """Sets the image_id of this CreateInstanceRequest.

        ImageId to be used to setup the compute instance. Default is Ubuntu 20.04  # noqa: E501

        :param image_id: The image_id of this CreateInstanceRequest.  # noqa: E501
        :type: str
        """
        if image_id is None:
            raise ValueError("Invalid value for `image_id`, must not be `None`")  # noqa: E501

        self._image_id = image_id

    @property
    def product_id(self):
        """Gets the product_id of this CreateInstanceRequest.  # noqa: E501

        You can find `productId`s [here](https://contabo.com/en/product-list/?show_ids=true). Default is V1  # noqa: E501

        :return: The product_id of this CreateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._product_id

    @product_id.setter
    def product_id(self, product_id):
        """Sets the product_id of this CreateInstanceRequest.

        You can find `productId`s [here](https://contabo.com/en/product-list/?show_ids=true). Default is V1  # noqa: E501

        :param product_id: The product_id of this CreateInstanceRequest.  # noqa: E501
        :type: str
        """
        if product_id is None:
            raise ValueError("Invalid value for `product_id`, must not be `None`")  # noqa: E501

        self._product_id = product_id

    @property
    def region(self):
        """Gets the region of this CreateInstanceRequest.  # noqa: E501

        Instance Region where the compute instance should be located. Default is EU  # noqa: E501

        :return: The region of this CreateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._region

    @region.setter
    def region(self, region):
        """Sets the region of this CreateInstanceRequest.

        Instance Region where the compute instance should be located. Default is EU  # noqa: E501

        :param region: The region of this CreateInstanceRequest.  # noqa: E501
        :type: str
        """
        if region is None:
            raise ValueError("Invalid value for `region`, must not be `None`")  # noqa: E501
        allowed_values = ["EU", "US-central", "US-east", "US-west", "SIN"]  # noqa: E501
        if region not in allowed_values:
            raise ValueError(
                "Invalid value for `region` ({0}), must be one of {1}"  # noqa: E501
                .format(region, allowed_values)
            )

        self._region = region

    @property
    def ssh_keys(self):
        """Gets the ssh_keys of this CreateInstanceRequest.  # noqa: E501

        Array of ids of public SSH Keys in order to access as admin user with root privileges (via sudo). Applies to Linux/BSD systems. Please refer to Secrets Management API.  # noqa: E501

        :return: The ssh_keys of this CreateInstanceRequest.  # noqa: E501
        :rtype: list[int]
        """
        return self._ssh_keys

    @ssh_keys.setter
    def ssh_keys(self, ssh_keys):
        """Sets the ssh_keys of this CreateInstanceRequest.

        Array of ids of public SSH Keys in order to access as admin user with root privileges (via sudo). Applies to Linux/BSD systems. Please refer to Secrets Management API.  # noqa: E501

        :param ssh_keys: The ssh_keys of this CreateInstanceRequest.  # noqa: E501
        :type: list[int]
        """

        self._ssh_keys = ssh_keys

    @property
    def root_password(self):
        """Gets the root_password of this CreateInstanceRequest.  # noqa: E501

        Password id for admin user with administrator/root privileges. For Linux/BSD please use SSH, for Windows RDP. Please refer to Secrets Management API.  # noqa: E501

        :return: The root_password of this CreateInstanceRequest.  # noqa: E501
        :rtype: int
        """
        return self._root_password

    @root_password.setter
    def root_password(self, root_password):
        """Sets the root_password of this CreateInstanceRequest.

        Password id for admin user with administrator/root privileges. For Linux/BSD please use SSH, for Windows RDP. Please refer to Secrets Management API.  # noqa: E501

        :param root_password: The root_password of this CreateInstanceRequest.  # noqa: E501
        :type: int
        """

        self._root_password = root_password

    @property
    def user_data(self):
        """Gets the user_data of this CreateInstanceRequest.  # noqa: E501

        [Cloud-Init](https://cloud-init.io/) Config in order to customize during start of compute instance.  # noqa: E501

        :return: The user_data of this CreateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._user_data

    @user_data.setter
    def user_data(self, user_data):
        """Sets the user_data of this CreateInstanceRequest.

        [Cloud-Init](https://cloud-init.io/) Config in order to customize during start of compute instance.  # noqa: E501

        :param user_data: The user_data of this CreateInstanceRequest.  # noqa: E501
        :type: str
        """

        self._user_data = user_data

    @property
    def license(self):
        """Gets the license of this CreateInstanceRequest.  # noqa: E501

        Additional licence in order to enhance your chosen product, mainly needed for software licenses on your product (not needed for windows).  # noqa: E501

        :return: The license of this CreateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._license

    @license.setter
    def license(self, license):
        """Sets the license of this CreateInstanceRequest.

        Additional licence in order to enhance your chosen product, mainly needed for software licenses on your product (not needed for windows).  # noqa: E501

        :param license: The license of this CreateInstanceRequest.  # noqa: E501
        :type: str
        """
        allowed_values = ["PleskHost", "PleskPro", "PleskAdmin", "cPanel5", "cPanel30", "cPanel50", "cPanel100", "cPanel150", "cPanel200", "cPanel250", "cPanel300", "cPanel350", "cPanel400", "cPanel450", "cPanel500", "cPanel550", "cPanel600", "cPanel650", "cPanel700", "cPanel750", "cPanel800", "cPanel850", "cPanel900", "cPanel950", "cPanel1000"]  # noqa: E501
        if license not in allowed_values:
            raise ValueError(
                "Invalid value for `license` ({0}), must be one of {1}"  # noqa: E501
                .format(license, allowed_values)
            )

        self._license = license

    @property
    def period(self):
        """Gets the period of this CreateInstanceRequest.  # noqa: E501

        Initial contract period in months. Available periods are: 1, 3, 6 and 12 months. Default to 1 month  # noqa: E501

        :return: The period of this CreateInstanceRequest.  # noqa: E501
        :rtype: int
        """
        return self._period

    @period.setter
    def period(self, period):
        """Sets the period of this CreateInstanceRequest.

        Initial contract period in months. Available periods are: 1, 3, 6 and 12 months. Default to 1 month  # noqa: E501

        :param period: The period of this CreateInstanceRequest.  # noqa: E501
        :type: int
        """
        if period is None:
            raise ValueError("Invalid value for `period`, must not be `None`")  # noqa: E501

        self._period = period

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateInstanceRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateInstanceRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
